
-- alter core schema
alter table public.user_attribute alter column value set data type text;
alter table public.user_attribute add column if not exists change_src boolean DEFAULT false;
COMMENT ON COLUMN user_attribute.change_src IS 'Признак нераспространения изменений через триггер в схему profile';


CREATE OR REPLACE FUNCTION create_constraint_if_not_exists (t_name text, c_name text, constraint_sql text)
  RETURNS void
AS
$BODY$
  BEGIN
    -- Look for our constraint
    IF NOT EXISTS (SELECT constraint_name
                   FROM information_schema.constraint_column_usage
                   WHERE constraint_name = c_name) THEN
        EXECUTE 'ALTER TABLE ' || t_name || ' ADD CONSTRAINT ' || c_name || ' ' || constraint_sql;
    END IF;
  END;
$BODY$
LANGUAGE plpgsql VOLATILE;

/*
ALTER TABLE ONLY user_attribute
    ADD CONSTRAINT uq_user_attribute UNIQUE (name, user_id);
*/

SELECT create_constraint_if_not_exists('user_attribute', 'uq_user_attribute', 'UNIQUE (name, user_id);');

/*
# WTF ? uq_user_attribute = user_attribute_uniq_chk
ALTER TABLE ONLY user_attribute
    ADD CONSTRAINT user_attribute_uniq_chk UNIQUE (name, user_id);
*/
SELECT create_constraint_if_not_exists('user_attribute', 'user_attribute_uniq_chk', 'UNIQUE (name, user_id);');

DROP FUNCTION create_constraint_if_not_exists (t_name text, c_name text, constraint_sql text);



